package com.liangjian11.ums.controller;


import com.baomidou.mybatisplus.plugins.Page;
import com.liangjian11.ums.model.organization.Oauth2ClientResource;
import com.liangjian11.ums.web.result.ResultInfo;
import com.liangjian11.ums.controller.base.BaseController;
import com.liangjian11.ums.service.organization.Oauth2ClientResourceService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * (Oauth2ClientResource)表控制层
 *
 * @author hsw
 * @since 2020-04-14 14:12:53
 */
@Api(value = "Oauth2客户端接口控制器", tags = "Oauth2客户端接口控制器")
@RestController
@RequestMapping("/oauth2ClientResource")
public class Oauth2ClientResourceController extends BaseController {
    /**
     * 服务对象
     */
    @Autowired
    private Oauth2ClientResourceService oauth2ClientResourceService;

    /**
     * 分页查询所有数据
     *
     * @param page 分页对象
     * @return 所有数据
     */
    @ApiOperation(value = "条件分页查询Oauth2ClientResource")
    @PostMapping("/searchByCondition")
    public ResultInfo selectAll(@ApiParam(value = "Page对象", required = true) @RequestBody Page<Oauth2ClientResource> page) {
        return new ResultInfo(ResultInfo.TYPE_RESULT_SUCCESS, 200, "", this.oauth2ClientResourceService.selectPage(page));
    }

    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @ApiOperation(value = "根据id查询 Oauth2ClientResource")
    @GetMapping("/{id}")
    public ResultInfo selectOne(@ApiParam(value = "ID", required = true) @PathVariable("id") Integer id) {
        return new ResultInfo(ResultInfo.TYPE_RESULT_SUCCESS, 200, "", this.oauth2ClientResourceService.selectById(id));
    }

    /**
     * 新增数据
     *
     * @param oauth2ClientResource 实体对象
     * @return 新增结果
     */
    @PostMapping("/add")
    @ApiOperation(value = "新增Oauth2ClientResource")
    public ResultInfo insert(@ApiParam(value = "Oauth2ClientResource", required = true) @RequestBody Oauth2ClientResource oauth2ClientResource) {
        return new ResultInfo(ResultInfo.TYPE_RESULT_SUCCESS, 200, "",this.oauth2ClientResourceService.insert(oauth2ClientResource));
    }

    /**
     * 修改数据
     *
     * @param oauth2ClientResource 实体对象
     * @return 修改结果
     */
    @PutMapping("/update")
    @ApiOperation(value = "根据id修改Oauth2ClientResource")
    public ResultInfo update(@ApiParam(value = "Oauth2ClientResource", required = true) @RequestBody Oauth2ClientResource oauth2ClientResource) {
        return new ResultInfo(ResultInfo.TYPE_RESULT_SUCCESS, 200, "", this.oauth2ClientResourceService.updateById(oauth2ClientResource));
    }

    /**
     * 删除数据
     *
     * @param idList 主键结合
     * @return 删除结果
     */
    @DeleteMapping("/delete")
    @ApiOperation(value = "删除Oauth2ClientResource")
    public ResultInfo delete(@ApiParam(value = "Oauth2ClientResource", required = true) @RequestParam("idList") List<Long> idList) {
        return new ResultInfo(ResultInfo.TYPE_RESULT_SUCCESS, 200, "",this.oauth2ClientResourceService.deleteBatchIds(idList));
    }
}