package com.liangjian11.ums.controller.base;

import com.liangjian11.ums.model.Account;
import com.liangjian11.ums.service.IUserService;
import com.liangjian11.ums.utils.JWTUtil;
import com.liangjian11.ums.utils.RequestCookieHelper;
import com.liangjian11.ums.utils.content.Config;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * 基础控制类 ，持续扩展
 */
public class BaseController {

    @Autowired
    private IUserService iUserService;

    public String getTokenUser(String key){
        String  token = RequestCookieHelper.getToken(Config.JWT_CUSTOMER_TOKEN_NAME);
        return JWTUtil.getUserValue(token,key);
    }

    public String getTokenUserId(String userName){
        Account account = this.iUserService.getUserByUserName(userName);
        return account.getId();
    }

}
