package com.liangjian11.ums.controller.shiro.dto.auth;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.apache.commons.lang3.StringUtils;

import javax.servlet.http.HttpServletRequest;


@ApiModel("获取token参数实体")
public class AuthTokenParams {
    HttpServletRequest httpRequest;

    public AuthTokenParams(){
    }

    public AuthTokenParams(HttpServletRequest request){
        this.httpRequest = request;
        this.userName = httpRequest.getParameter("username");
        this.password = httpRequest.getParameter("password");
        this.applicationKey = httpRequest.getParameter("applicationKey");
        this.applicationSecret = httpRequest.getParameter("applicationSecret");
        String autoRefresh = httpRequest.getParameter("autoRefresh");
        this.autoRefresh =  StringUtils.isEmpty(autoRefresh) ?false:Boolean.parseBoolean(autoRefresh);
    }
    @ApiModelProperty(value = "用户名", required = true)
    private String userName;

    @ApiModelProperty(value = "密码", required = true)//公钥
    private String password;

    @ApiModelProperty(value = "密码", required = true)//私钥
    private String passwordPriv;

    @ApiModelProperty(value = "所属项目key", required = true)
    private String applicationKey;

    @ApiModelProperty(value = "所属项目secret", required = true)
    private String applicationSecret;

    @ApiModelProperty(value = "是否自动刷新token", required = true)
    private Boolean autoRefresh;

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getPasswordPriv() {
        return passwordPriv;
    }

    public void setPasswordPriv(String passwordPriv) {
        this.passwordPriv = passwordPriv;
    }

    public String getApplicationKey() {
        return applicationKey;
    }

    public void setApplicationKey(String applicationKey) {
        this.applicationKey = applicationKey;
    }


    public String getApplicationSecret() {
        return applicationSecret;
    }

    public void setApplicationSecret(String applicationSecret) {
        this.applicationSecret = applicationSecret;
    }

    public Boolean getAutoRefresh() {
        return autoRefresh;
    }

    public void setAutoRefresh(Boolean autoRefresh) {
        this.autoRefresh = autoRefresh;
    }
}
