package com.liangjian11.ums.dao.foo;

import com.liangjian11.ums.model.Role;
import com.baomidou.mybatisplus.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Mapper
@Repository
public interface RoleMapper extends BaseMapper<Role> {

    /**
     * 根据条件查询角色列表(分页)
     *
     * @param filterSql
     * @param start
     * @param PageSize
     * @return
     */
    List<Role> selectByCondition(@Param("filterSql") String filterSql, @Param("start") int start, @Param("pageSize") int PageSize);

    /**
     * 根据条件查询角色列表行数
     *
     * @param filterSql
     * @return
     */
    Integer selectCountByCondition(@Param("filterSql") String filterSql);

    /**
     * 根据RoleID查询Role及其权限
     *
     * @param roleId
     * @return
     */
    Role selectRoleByRoleId(@Param("roleId") String roleId);

    /**
     * 查询当前用户拥有的角色集合
     *
     * @param accountId
     * @return
     */
    List<Role> selectByUser(@Param("accountId") String accountId);


    /**
     * 查询当前用户锁拥有当前系统的角色集合
     *
     * @param userId
     * @param applicationKey
     * @return
     */
    List<Role> getRolesByUserAndAppKey(@Param("userId") String userId, @Param("applicationKey") String applicationKey);


}