package com.liangjian11.ums.dao.foo;

import com.liangjian11.ums.model.SysMenu;
import com.baomidou.mybatisplus.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface SysMenuMapper extends BaseMapper<SysMenu> {

    /**
     * 根据用户及项目key查询当前用户拥有的资源
     *
     * @param userId         用户id
     * @param applicationKey 项目key
     * @return
     */
    List<SysMenu> getResourcesByUserAndAppKey(@Param("userId") String userId, @Param("applicationKey") String applicationKey);

    /**
     * 获取当前项目所有资源
     *
     * @param applicationKey
     * @return
     */
    List<SysMenu> getResourcesByAppKey(@Param("applicationKey") String applicationKey);
}