package com.liangjian11.ums.model;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;

import java.util.List;
import java.io.Serializable;
import java.util.Date;

//import org.springframework.security.core.GrantedAuthority;
//import org.springframework.security.core.userdetails.UserDetails;
@TableName("Account")
public class Account extends Model<Account>  {

    private static final long serialVersionUID = 1L;

    //@TableId(type = IdType.AUTO)
    @TableId("id")
    private String id;
    @TableField("loginId")
    private String loginId;
    @TableField("nickName")
    private String nickName;

    @TableField("password1")
    private String password;

    @TableField("accountCode")
    private String accountCode;


    @TableField("encrypteType")
    private String encrypteType;
    /**
     * 0：注销?，2:激活 -4:删除?
     */
    @TableField("recordState")
    private Integer recordState;

    @TableField("creationDate")
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date creationDate;

    @TableField("createByUser")
    private String createByUser;

    @TableField("lastModified")
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date lastModified;

    @TableField("updateByUser")
    private String updateByUser;

    @TableField("isLockBuyUser")
    private boolean isLockBuyUser;

    @TableField("secret")
    private String secret;

    @TableField("Status")
    private Integer status;

    @TableField("password")
    private String password1;
    @TableField("phoneNumber")
    private String phoneNumber;


    //@TableField("roleKey")
    @TableField(exist = false)
    private String roleKey;
    //@TableField("deptCode")
    @TableField(exist = false)
    private String deptCode;
    //@TableField("orgKey")
    @TableField(exist = false)
    private String orgKey;
    //@TableField("extra")//额外信息 json格式 字符串不能有下划线
    @TableField(exist = false)//额外信息 json格式 字符串不能有下划线
    private String extra;
    @TableField(exist = false)
    private List<Role> roleList;//角色列表



    public void setPassword1(String password1) {
        this.password1 = password1;
    }

    public String getPassword1() {
        return password1;
    }

    public Integer getStatus() {
        return status;
    }
    public void setStatus(Integer status) {
        this.status = status;
    }

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getLoginId() {
        return loginId;
    }

    public void setLoginId(String loginId) {
        this.loginId = loginId;
    }

    public String getNickName() {
        return nickName;
    }

    public void setNickName(String nickName) {
        this.nickName = nickName;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getAccountCode() {
        return accountCode;
    }

    public void setAccountCode(String accountCode) {
        this.accountCode = accountCode;
    }

    public String getEncrypteType() {
        return encrypteType;
    }

    public void setEncrypteType(String encrypteType) {
        this.encrypteType = encrypteType;
    }

    public Integer getRecordState() {
        return recordState;
    }

    public void setRecordState(Integer recordState) {
        this.recordState = recordState;
    }

    public Date getCreateDate() {
        return creationDate;
    }

    public void setCreateDate(Date createDate) {
        this.creationDate = createDate;
    }

    public String getCreateByUser() {
        return createByUser;
    }

    public void setCreateByUser(String createByUser) {
        this.createByUser = createByUser;
    }

    public Date getLastModified() {
        return this.lastModified;
    }

    public void setLastModified(Date lastModified) {
        this.lastModified = lastModified;
    }

    public String getUpdateByUser() {
        return this.updateByUser;
    }

    public void setUpdateByUser(String updateUser) {
        this.updateByUser = updateUser;
    }

    public boolean isLockBuyUser() {
        return isLockBuyUser;
    }

    public void setLockBuyUser(boolean lockBuyUser) {
        this.isLockBuyUser = lockBuyUser;
    }

    public String getSecret() {
        return this.secret;
    }

    public void setSecret(String secret) {
        this.secret = secret;
    }

    public List<Role> getRoleList() {
        return roleList;
    }

    public void setRoleList(List<Role> roleList) {
        this.roleList = roleList;
    }
//    @Override
//    public Collection<? extends GrantedAuthority> getAuthorities() {
//        return null;
//    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public String getRoleKey() {
        return roleKey;
    }

    public void setRoleKey(String roleKey) {
        this.roleKey = roleKey;
    }

    public String getDeptCode() {
        return deptCode;
    }

    public void setDeptCode(String deptCode) {
        this.deptCode = deptCode;
    }

    public String getOrgKey() {
        return orgKey;
    }

    public void setOrgKey(String orgKey) {
        this.orgKey = orgKey;
    }

    public String getExtra() {
        return extra;
    }

    public void setExtra(String extra) {
        this.extra = extra;
    }

    public String getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }
}
