package com.liangjian11.ums.model;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.experimental.Accessors;
import java.util.List;
import java.io.Serializable;
import java.util.Date;

/**
 * 权限表(Resource)表实体类
 *
 * @author hsw
 * @since 2020-04-14 14:12:53
 */
//@Data
@Accessors(chain = true)
@ApiModel("接口表")
@SuppressWarnings("serial")
@TableName(value = "SysMenu")
public class InterfaceResource extends Model<InterfaceResource> {
    @ApiModelProperty("resId")
    @TableField("resId")
    @TableId(type = IdType.AUTO)
    private Integer resId;

    @ApiModelProperty("Id")
    private String id;

    @ApiModelProperty("parentId")
    @TableField("parentId")
    private String parentId;

    @ApiModelProperty("appId")
    @TableField("appId")
    private Integer appId;

    @ApiModelProperty("resourceTypeId")
    @TableField("resourceTypeId")
    private Integer resourceTypeId;

    @ApiModelProperty("menuName")
    @TableField("menuName")
    private String MenuName;

    @ApiModelProperty("资源编码")
    @TableField("code")
    private String code;

    @ApiModelProperty("linkUrl")
    @TableField("LinkUrl")
    private String LinkUrl;

    @ApiModelProperty("description")
    @TableField("description")
    private String description;

    @ApiModelProperty("0:系统,1:菜单,2:Api")
    @TableField(value = "types")
    private Integer types;

    @ApiModelProperty("icon")
    @TableField("icon")
    private String icon;


    @ApiModelProperty("0:禁用 1:启用 -3:垃圾桶 -4:删除")
    @TableField("status")
    private Integer status;

    @ApiModelProperty("createTime")
    @TableField("createTime")
    private Date createTime;

    @ApiModelProperty("createUserId")
    @TableField("createUserId")
    private String createUserId;

    @ApiModelProperty("updateTime")
    @TableField("updateTime")
    private Date updateTime;

    @ApiModelProperty("updateUserId")
    @TableField("updateUserId")
    private Integer updateUserId;


    @ApiModelProperty("parentResourceUid")
//    @TableField("parentResourceUid")
    @TableField(exist = false)
    private String parentResourceUid;

    @ApiModelProperty("roleIds")
    @TableField(value="roleIds",exist = false)
    private String roleIds;


    @ApiModelProperty("parentResId")
    @TableField("parentResId")
    private Integer parentResId;

    @ApiModelProperty("orderNum")
    @TableField("orderNum")
    private Integer orderNum;

    @ApiModelProperty("pageName")
    @TableField("pageName")
    private String pageName;

    @ApiModelProperty("actionType")
    @TableField("actionType")
    private String actionType;

    @ApiModelProperty("isVisible")
    @TableField("isVisible")
    private Integer isVisible;

    @ApiModelProperty("AppName")
    @TableField(value="AppName",exist = false)
    private String appName;


    /**
     * 获取主键值
     *
     * @return 主键值
     */
    @Override
    protected Serializable pkVal() {
        return this.resId;
    }

    public Integer getResId() {
        return resId;
    }

    public void setResId(Integer resId) {
        this.resId = resId;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public Integer getParentResId() {
        return parentResId;
    }

    public void setParentResId(Integer parentResId) {
        this.parentResId = parentResId;
    }

    public Integer getAppId() {
        return appId;
    }

    public void setAppId(Integer appId) {
        this.appId = appId;
    }

    public Integer getResourceTypeId() {
        return resourceTypeId;
    }

    public void setResourceTypeId(Integer resourceTypeId) {
        this.resourceTypeId = resourceTypeId;
    }

    public String getMenuName() {
        return MenuName;
    }

    public void setMenuName(String MenuName) {
        this.MenuName = MenuName;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getLinkUrl() {
        return LinkUrl;
    }

    public void setLinkUrl(String LinkUrl) {
        this.LinkUrl = LinkUrl;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Integer getTypes() {
        return types;
    }

    public void setTypes(Integer types) {
        this.types = types;
    }

    public String getIcon() {
        return icon;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getCreateUserId() {
        return createUserId;
    }

    public void setCreateUserId(String createUserId) {
        this.createUserId = createUserId;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getUpdateUserId() {
        return updateUserId;
    }

    public void setUpdateUserId(Integer updateUserId) {
        this.updateUserId = updateUserId;
    }

    public String getParentResourceUid() {
        return parentResourceUid;
    }

    public void setParentResourceUid(String parentResourceUid) {
        this.parentResourceUid = parentResourceUid;
    }

    public String getRoleIds() {
        return roleIds;
    }

    public void setRoleIds(String roleIds) {
        this.roleIds = roleIds;
    }

    public Integer getOrderNum() {
        return orderNum;
    }

    public void setOrderNum(Integer orderNum) {
        this.orderNum = orderNum;
    }

    public String getActionType() {
        return actionType;
    }

    public void setActionType(String actionType) {
        this.actionType = actionType;
    }

    public String getPageName() {
        return pageName;
    }

    public void setPageName(String pageName) {
        this.pageName = pageName;
    }

    public Integer getIsVisible() {
        return isVisible;
    }

    public void setIsVisible(Integer isVisible) {
        this.isVisible = isVisible;
    }

    public String getAppName() {
        return appName;
    }

    public void setAppName(String appName) {
        this.appName = appName;
    }

}