package com.liangjian11.ums.model;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;

import java.util.List;
import java.io.Serializable;
import java.util.Date;

@TableName("SysRole")
public class Role extends Model<Role> {

    private static final long serialVersionUID = 1L;

    //@TableId(type = IdType.AUTO)
    @TableId("id")
    private String id;

    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    @TableField("CreationDate")
    private Date creationDate;

    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    @TableField("LastModified")
    private Date lastModified;

    /**
     * 状态，
     */
    @TableField("RecordState")
    private Integer RecordState;

    /**
     * 角色名称
     */
    @TableField("RoleName")
    private String roleName;

    @TableField("OrganizationCode")
    private String organizationCode;


    @TableField("CreateByUser")
    private String createByUser;


    @TableField("LastModifiedUser")
    private String lastModifiedUser;

    /**
     * 角色描述
     */
    @TableField("Remark")
    private String remark;

    /**
     * appid
     */
    @TableField("AppId")
    private Integer appId;

    /**
     * 项目key
     */
    @TableField("Application_Key")
    private String applicationKey;

    /**
     * rolekey
     */
    @TableField("Role_Key")
    private String roleKey;

    /**
     * 状态，0：禁用 1：启用 -4:删除
     */
    @TableField("Status")
    private Integer status;

    /**
     * 角色权限对象数组
     */
    @TableField(exist = false)
    private List<InterfaceResource> resourceList;


    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public Date getLastModified() {
        return lastModified;
    }

    public void setLastModified(Date lastModified) {
        this.lastModified = lastModified;
    }

    public Integer getRecordState() {
        return RecordState;
    }

    public void setRecordState(Integer recordState) {
        RecordState = recordState;
    }

    public String getRoleName() {
        return roleName;
    }

    public void setRoleName(String roleName) {
        this.roleName = roleName;
    }

    public String getOrganizationCode() {
        return organizationCode;
    }

    public void setOrganizationCode(String organizationCode) {
        this.organizationCode = organizationCode;
    }

    public String getCreateByUser() {
        return createByUser;
    }

    public void setCreateByUser(String createByUser) {
        this.createByUser = createByUser;
    }

    public String getLastModifiedUser() {
        return lastModifiedUser;
    }

    public void setLastModifiedUser(String lastModifiedUser) {
        this.lastModifiedUser = lastModifiedUser;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Integer getAppId() {
        return appId;
    }

    public void setAppId(Integer appId) {
        this.appId = appId;
    }

    public String getApplicationKey() {
        return applicationKey;
    }

    public void setApplicationKey(String applicationKey) {
        this.applicationKey = applicationKey;
    }

    public String getRoleKey() {
        return roleKey;
    }

    public void setRoleKey(String role_Key) {
        roleKey = role_Key;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public List<InterfaceResource> getResourceList() {
        return resourceList;
    }

    public void setResourceList(List<InterfaceResource> resourceList) {
        this.resourceList = resourceList;
    }

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
