package com.liangjian11.ums.model.common;

public class FilterRule
{
    private static final long serialVersionUID = 1L;
    private String field;
    private Object value;
    private String operate;
    private String type;
    public FilterRule()
    {
    }
    public FilterRule(String field, Object value)
    {
        this.field = field;
        this.value = value;
        this.operate = "equal";
    }

    public FilterRule(String field, Object value, String operate)
    {
        this.field = field;
        this.value = value;
        this.operate = operate;
    }

    public String getField() {
        return field;
    }

    public void setField(String field) {
        this.field = field;
    }

    public Object getValue() {
        return value;
    }

    public void setValue(Object value) {
        this.value = value;
    }

    public String getOperate() {
        return operate;
    }

    public void setOperate(String operate) {
        this.operate = operate;
    }
    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String toSql() {
        //改成预编译的形式
        switch (this.operate) {
            case "equal": return String.format(" and %s = %s",field, value);
            case "notequal": return String.format(" and %s != %s",field, value);
            case "less": return String.format(" and %s < %s",field,value);
            case "lessorequal": return String.format(" and %s <= %s",field, value);
            case "greater": return String.format(" and %s > %s",field,value);
            case "greateroreeuqal": return String.format(" and %s >= %s",field, value);
            case "contains": return " and " + field + " like '%" + value + "%'";
            case "startswith": return " and " + field + " like '" + value + "%'";
            case "endswith": return " and " + field + " like '%" + value + "'";
            default: return "";
        }

//        switch (this.operate) {
//            case "equal":
//                return String.format(" and %s = ?", field);
//            case "notequal":
//                return String.format(" and %s != ?", field);
//            case "less":
//                return String.format(" and %s < ?", field);
//            case "lessorequal":
//                return String.format(" and %s <= ?", field);
//            case "greater":
//                return String.format(" and %s > ?", field);
//            case "greateroreeuqal":
//                return String.format(" and %s >= ?", field);
//            case "contains":
//                return " and " + field + " like ?";
//            case "startswith":
//                return " and " + field + " like ?";
//            case "endswith":
//                return " and " + field + " like ?";
//            default:
//                return "";
//        }
    }

    public String toSqlString() {
        //改成预编译的形式
        switch (this.operate) {
            case "equal": return String.format(" and %s = '%s'",field, value);
            case "notequal": return String.format(" and %s != '%s'",field, value);
            case "less": return String.format(" and %s < '%s'",field,value);
            case "lessorequal": return String.format(" and %s <= '%s'",field, value);
            case "greater": return String.format(" and %s > '%s'",field,value);
            case "greateroreeuqal": return String.format(" and %s >= '%s'",field, value);
            case "contains": return " and " + field + " like '%" + value + "%'";
            case "startswith": return " and " + field + " like '" + value + "%'";
            case "endswith": return " and " + field + " like '%" + value + "'";
            default: return "";
        }
    }

}
