package com.liangjian11.ums.model.common;


import org.springframework.util.StringUtils;

import java.util.List;
import java.util.Map;

public class FiltersUtils {

    //查询添加
    private String field;
    private String operate;
    private String value;
    private List<Map<String, Object>> rules;

    public FiltersUtils() {

    }

    public FiltersUtils(String field, String operate, String value) {
        this.field = field;
        this.operate = operate;
        this.value = value;
    }

    public List<Map<String, Object>> getRules() {
        return rules;
    }

    public void setRules(List<Map<String, Object>> rules) {
        this.rules = rules;
    }


    public String getField() {
        return field;
    }

    public void setField(String field) {
        this.field = field;
    }

    public String getOperate() {
        return operate;
    }

    public void setOperate(String operate) {
        this.operate = operate;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    private static StringBuilder strBuffer = new StringBuilder();

    /**
     * 驼峰转 _
     */
    public static void bigToLine(List<FiltersUtils> list) {
        synchronized (strBuffer) {
            if (list == null || list.size() == 0)
                return;
            for (FiltersUtils filtersUtil : list) {
                if (filtersUtil != null && !StringUtils.isEmpty(filtersUtil.getField())) {
                    strBuffer.delete(0, strBuffer.length());
                    for (int i = 0; i < filtersUtil.getField().length(); i++) {
                        if (Character.isUpperCase(filtersUtil.getField().charAt(i))) {
                            strBuffer.append("_");
                            strBuffer.append(Character.toLowerCase(filtersUtil.getField().charAt(i)));
                        } else {
                            strBuffer.append(filtersUtil.getField().charAt(i));
                        }
                    }
                    filtersUtil.setField(strBuffer.toString());
                }
            }
        }
    }

    /**
     * 排序列名驼峰转 _
     */
    public static String sortBigToLine(String sortField) {
        StringBuilder stringBuilder = new StringBuilder();
        for (int i = 0; i < sortField.length(); i++) {
            if (Character.isUpperCase(sortField.charAt(i))) {
                stringBuilder.append("_");
                stringBuilder.append(Character.toLowerCase(sortField.charAt(i)));
            } else {
                stringBuilder.append(sortField.charAt(i));
            }
        }
        sortField=stringBuilder.toString();
        return sortField;
    }
}
