package com.liangjian11.ums.model.common;

import com.liangjian11.ums.utils.RequestCookieHelper;
import com.liangjian11.ums.utils.content.Config;
import com.liangjian11.ums.service.IOAuthService;
import org.apache.oltu.oauth2.common.exception.OAuthSystemException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class JwtTokenHelper {

    protected static IOAuthService oAuthService;

    @Autowired
    public void setRedisTemplate(IOAuthService oAuthService) {
        JwtTokenHelper.oAuthService = oAuthService;
    }

    public static String getTokenValue(String name) throws OAuthSystemException {
        String token = RequestCookieHelper.getToken(Config.JWT_CUSTOMER_TOKEN_NAME);
        String tokenValue = oAuthService.getUsernameByAccessToken(token);

        String[] paramarr = tokenValue.split("_");
        if(paramarr.length < 7 ){
            throw new OAuthSystemException("prameter : 7 strings concat with _ between");
        }
        String username = paramarr[0];
        String password = paramarr[1];
        String applicationKey = paramarr[2];
        String roleKey = paramarr[3];
        String deptCode = paramarr[4];
        String orgKey = paramarr[5];
        long activeTime = Long.valueOf(paramarr[6]);

        String value = null;
        switch (name){
            case "CurrentUserID":
                System.out.println("hello CurrentUserID");
                break;
            case "CurrentUserKey":
                value = username;
                break;
            case "CurrentRoleID":
                System.out.println("hello CurrentRoleID");
                break;
            case "CurrentRoleKey":
                value = roleKey;
                break;
            case "CurrentDeptID":
                System.out.println("world CurrentDeptID");
                break;
            case "CurrentDeptCode":
                value = deptCode;
                break;
            case "CurrentEmployeeID":
                System.out.println("world CurrentEmployeeID");
                break;
            case "CurrentSupplierID":
                System.out.println("world CurrentSupplierID");
                break;
            default:
                break;

        }
        return value;
    }

    public static String setTokenValue(String name,String value) throws OAuthSystemException {
        String token = RequestCookieHelper.getToken(Config.JWT_CUSTOMER_TOKEN_NAME);
        String tokenValue = oAuthService.getUsernameByAccessToken(token);

        String[] paramarr = tokenValue.split("_");
        if(paramarr.length < 7 ){
            throw new OAuthSystemException("prameter : 7 strings concat with _ between");
        }
        String username = paramarr[0];
        String password = paramarr[1];
        String applicationKey = paramarr[2];
        String roleKey = paramarr[3];
        String deptCode = paramarr[4];
        String orgKey = paramarr[5];
        long activeTime = Long.valueOf(paramarr[6]);

        switch (name){
            case "CurrentUserID":
                System.out.println("hello CurrentUserID");
                break;
            case "CurrentUserKey":
                username = value;
                break;
            case "CurrentRoleID":
                System.out.println("hello CurrentRoleID");
                break;
            case "CurrentRoleKey":
                roleKey = value;
                break;
            case "CurrentDeptID":
                System.out.println("world CurrentDeptID");
                break;
            case "CurrentDeptCode":
                deptCode = value;
                break;
            case "CurrentEmployeeID":
                System.out.println("world CurrentEmployeeID");
                break;
            case "CurrentSupplierID":
                System.out.println("world CurrentSupplierID");
                break;
            default:
                break;
        }

        String tokendata = username+"_"+password+"_"+applicationKey+"_"+roleKey+"_"+deptCode+"_"+orgKey+"_"+activeTime;
        oAuthService.removeAccessToken(token);
        oAuthService.addAccessToken(token,tokendata);
        return value;
    }

}
