package com.liangjian11.ums.model.organization;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.enums.IdType;
import com.liangjian11.ums.model.Client;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Date;

/**
 * (Orgdoc)表实体类
 *
 * @author hsw
 * @since 2020-04-14 14:12:53
 */
@ApiModel("$tableInfo.comment")
@SuppressWarnings("serial")
public class Orgdoc extends Model<Orgdoc> {
//    @TableId(type = IdType.AUTO, value = "Id")
//    @ApiModelProperty("Id")
//    private Integer id;

    @ApiModelProperty("机构id")
    @TableId(type = IdType.INPUT,value = "OrgId")
    private Integer orgId;

    @ApiModelProperty("entId")
    @TableField(value = "EntId")
    private Integer entId;

    @ApiModelProperty("所属平台")
    @TableField(value = "ParentName")
    private String parentName;

    @ApiModelProperty("机构名称")
    @TableField(value = "OrgName")
    private String orgName;

    @ApiModelProperty("0 内部机构 1 外部机构")
    @TableField(value = "TypeId")
    private Integer typeId;

    @ApiModelProperty("oauth2客户端id")
    @TableField(value = "Oauth2ClientId")
    private Long oauth2ClientId;

    @ApiModelProperty("0:禁用 1:启用 -3:垃圾桶 -4:删除")
    @TableField(value = "AuthStatus")
    private Integer authStatus;

    @ApiModelProperty("端口数")
    @TableField(value = "AuthNum")
    private Integer authNum;

    @ApiModelProperty("创建时间")
    @TableField(value = "CreateTime")
    private Date createTime;

    @ApiModelProperty("创建用户")
    @TableField(value = "CreateUserId")
    private Integer createUserId;

    @ApiModelProperty("更新时间")
    @TableField(value = "UpdateTime")
    private Date updateTime;

    @ApiModelProperty("更新用户")
    @TableField(value = "UpdateUserId")
    private Integer updateUserId;

    @ApiModelProperty("ips")
    @TableField(value = "Ips")
    private String ips;

    @ApiModelProperty("密钥")
    @TableField(value = "Secret")
    private String secret;

    @ApiModelProperty("父机构名称")
    @TableField(value = "ParentOrgId")
    private String parentOrgId;

    @ApiModelProperty("机构唯一id")
    @TableField(value = "OrgUid")
    private String orgUId;

    @ApiModelProperty("父机构唯一id")
    @TableField(value = "ParentOrgUId")
    private String parentOrgUId;

    @ApiModelProperty("机构key")
    @TableField(value = "OrgKey")
    private String orgKey;

    @ApiModelProperty("客户端id")
    @TableField(exist = false)
    private Client client;

    @ApiModelProperty("clientId")
    @TableField(value = "clientid",exist = false)
    private String clientId;

    @ApiModelProperty("clientSecret")
    @TableField(value = "clientsecret",exist = false)
    private String clientSecret;

    @ApiModelProperty("ClientPrivSecret")
    @TableField(value = "clientprivsecret",exist = false)
    private String clientPrivSecret;

    @ApiModelProperty("clientSecretType")
    @TableField(value = "clientsecrettype",exist = false)
    private String clientSecretType;
    /**
     * 获取主键值
     *
     * @return 主键值
     */
    @Override
    protected Serializable pkVal() {
        return this.orgId;
    }

    public Integer getOrgId() {
        return orgId;
    }

    public void setOrgId(Integer orgId) {
        this.orgId = orgId;
    }

    public Integer getEntId() {
        return entId;
    }

    public void setEntId(Integer entId) {
        this.entId = entId;
    }

    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public Integer getTypeId() {
        return typeId;
    }

    public void setTypeId(Integer typeId) {
        this.typeId = typeId;
    }

    public Long getOauth2ClientId() {
        return oauth2ClientId;
    }

    public void setOauth2ClientId(Long oauth2ClientId) {
        this.oauth2ClientId = oauth2ClientId;
    }

    public Integer getAuthStatus() {
        return authStatus;
    }

    public void setAuthStatus(Integer authStatus) {
        this.authStatus = authStatus;
    }

    public Integer getAuthNum() {
        return authNum;
    }

    public void setAuthNum(Integer authNum) {
        this.authNum = authNum;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Integer getCreateUserId() {
        return createUserId;
    }

    public void setCreateUserId(Integer createUserId) {
        this.createUserId = createUserId;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getUpdateUserId() {
        return updateUserId;
    }

    public void setUpdateUserId(Integer updateUserId) {
        this.updateUserId = updateUserId;
    }

    public String getIps() {
        return ips;
    }

    public void setIps(String ips) {
        this.ips = ips;
    }

    public String getSecret() {
        return secret;
    }

    public void setSecret(String secret) {
        this.secret = secret;
    }

    public String getParentOrgId() {
        return parentOrgId;
    }

    public void setParentOrgId(String parentOrgId) {
        this.parentOrgId = parentOrgId;
    }

    public String getOrgUId() {
        return orgUId;
    }

    public void setOrgUId(String orgUId) {
        this.orgUId = orgUId;
    }

    public String getParentOrgUId() {
        return parentOrgUId;
    }

    public void setParentOrgUId(String parentOrgUId) {
        this.parentOrgUId = parentOrgUId;
    }

    public String getOrgKey() {
        return orgKey;
    }

    public void setOrgKey(String orgKey) {
        this.orgKey = orgKey;
    }

    public Client getClient() {
        return client;
    }

    public void setClient(Client client) {
        this.client = client;
    }

    public String getClientId() {
        return clientId;
    }

    public void setClientId(String clientId) {
        this.clientId = clientId;
    }

    public String getClientSecret() {
        return clientSecret;
    }

    public void setClientSecret(String clientSecret) {
        this.clientSecret = clientSecret;
    }

    public String getClientPrivSecret() {
        return clientPrivSecret;
    }

    public void setClientPrivSecret(String clientPrivSecret) {
        this.clientPrivSecret = clientPrivSecret;
    }

    public String getClientSecretType() {
        return clientSecretType;
    }

    public void setClientSecretType(String clientSecretType) {
        this.clientSecretType = clientSecretType;
    }
}