package com.liangjian11.ums.model.organization;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.enums.IdType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * 接口类型表(ResourceType)表实体类
 *
 * @author hsw
 * @since 2020-04-14 14:12:53
 */
@Data
@Accessors(chain = true)
@ApiModel("接口类型表")
@SuppressWarnings("serial")
public class ResourceType extends Model<ResourceType> {
    @TableId(type = IdType.AUTO)
    @ApiModelProperty("接口类型id")
    private Integer id;

    @ApiModelProperty("接口类型名称")
    private String name;

    @ApiModelProperty("创建时间")
    private Date createTime;

    @ApiModelProperty("更新时间")
    private Date updateTime;

    @ApiModelProperty("创建用户")
    private String createUser;

    @ApiModelProperty("更新用户")
    private String updateUser;


    /**
     * 获取主键值
     *
     * @return 主键值
     */
    @Override
    protected Serializable pkVal() {
        return this.id;
    }
}