package com.liangjian11.ums.service;

public interface IOAuthService {

    void addAuthCode(String authCode, String username);// 添加 auth code

    String removeAuthCode(String authCode); // 移除auth code

    void addAccessToken(String accessToken, String username); // 添加 access token

    String getAccessToken(String username) ;//获取access token

    String getAccessUserByToken(String token);//获取access token

    boolean checkAuthCode(String authCode); // 验证 auth code 是否有效

    boolean checkAccessToken(String accessToken); // 验证 access token 是否有效

    String removeAccessToken(String accessToken); // 移除 access token

    String removeAccessToken(String accessToken,String username); // 移除 access token

    String getUsernameByAuthCode(String authCode);// 根据 auth code 获取用户名

    String getUsernameByAccessToken(String accessToken);// 根据 access token 获取用户名

    long getExpireIn();//auth code / access token 过期时间

    boolean checkClientId(String clientId);// 检查客户端 id 是否存在

    boolean checkClientSecret(String clientSecret);// 检查客户端安全 KEY 是否存在

}
