package com.liangjian11.ums.service;

import com.liangjian11.ums.model.SysMenu;
import com.liangjian11.ums.model.Account;
import com.baomidou.mybatisplus.service.IService;

import java.util.List;

public interface ISysMenuService extends IService<SysMenu> {

    /**
     * 根据用户及项目key查询当前用户拥有的资源
     *
     * @param currentUser    用户
     * @param applicationKey 项目key
     * @return
     */
    List<SysMenu> getResourcesByUserAndAppKey(Account currentUser, String applicationKey);

    /**
     * 获取当前项目所有资源
     *
     * @param applicationKey
     * @return
     */
    List<SysMenu> getResourcesByAppKey(String applicationKey);
}
