package com.liangjian11.ums.service;

import com.liangjian11.ums.model.Account;
import com.baomidou.mybatisplus.service.IService;
import com.liangjian11.ums.model.UserRole;
import com.liangjian11.ums.web.result.ResultInfo;

import java.util.List;


public interface IUserService extends IService<Account> {

    /**
     * 根据条件查询用户
     * @param filterSql
     * @param start
     * @param pageSize
     * @return
     */
    List<Account> getUserByCondition(String filterSql,Integer start,Integer pageSize);

    /**
     * 根据条件查询出的行数
     * @param filterSql
     * @return
     */
    Integer selectCountByCondition(String filterSql);


    /**
     * 新增用户及关联角色
     * @param account
     * @return
     */
    ResultInfo insertUserWithRole(Account account);


    /**
     * 更新用户及关联角色
     * @param account
     * @return
     */
    ResultInfo updateUserWithRole(Account account) ;

    /**
     * 删除用户及角色关联关系
     * @param userId
     * @return
     */
    ResultInfo deleteUserWithRole(String userId);

    /**
     * 查询出数据库最大AccountCode
     * @return
     */
    String selectMaxAccountCode();



    /**
     * 根据用户名获取用户
     * @param username
     * @return
     */
    Account getUserByUserName(String username);
}
