package com.liangjian11.ums.service;


import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.liangjian11.ums.model.Account;
import com.liangjian11.ums.model.InterfaceResource;
import com.liangjian11.ums.model.common.PageExt;
import com.liangjian11.ums.utils.TreeNode;

import java.util.List;

/**
 * 权限表(Resource)表服务接口
 *
 * @author hsw
 * @since 2020-04-14 14:12:53
 */
public interface InterfaceResourceService extends IService<InterfaceResource> {


    PageExt<InterfaceResource> selectResourcePage(PageExt<InterfaceResource> page);
    List<InterfaceResource>  selectResourcePage(String filterSql ,int start, int pageSize);
    Integer selectCountByCondition(String filterSql);

    List<InterfaceResource> selectAll();

    /**
     * 根据用户及项目key查询当前用户拥有的资源
     *
     * @param currentUser    用户
     * @param applicationKey 项目key
     * @return
     */
    List<InterfaceResource> getResourcesByUserAndAppKey(Account currentUser, String applicationKey, Integer types, String grantType);

    /**
     * 获取当前项目所有资源
     *
     * @param applicationKey
     * @return
     */
    List<InterfaceResource> getResourcesByAppKey(String applicationKey,Integer types);

    /**
     * 获取当前用户角色的所有资源
     *
     * @param autypes
     * @param roleKey
     * @return
     */
    List<InterfaceResource> getResourcesByRoleKey(String autypes,String roleKey,String applicationKey,Boolean parent);

    /**
     * 条件分页查询接口资源
     * @param page
     * @return
     */
    Page selectResourceByPage(PageExt<InterfaceResource> page);

    void addResource(InterfaceResource resource);

    Boolean insertRes(InterfaceResource resource);

    List<TreeNode> listResourceTree();

}