package com.liangjian11.ums.service.impl;

import com.liangjian11.ums.dao.foo.ApplicationMapper;
import com.liangjian11.ums.model.Application;
import com.liangjian11.ums.service.IApplicationService;
import com.liangjian11.ums.exception.AuthException;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
@Transactional(transactionManager = "fooManager")
public class ApplicationServiceImpl extends ServiceImpl<ApplicationMapper, Application> implements IApplicationService {

    @Override
    @Transactional(readOnly = true)
    public Application getApplicationByAppkey(String applicationKey) {
        if (StringUtils.isBlank(applicationKey)) {
            throw new AuthException("Params invalid!", 504);
        }
        EntityWrapper entityWrapper = new EntityWrapper<Application>();
        entityWrapper.eq("application_key", applicationKey);
        return this.selectOne(entityWrapper);
    }
}
