package com.liangjian11.ums.service.impl;

import com.liangjian11.ums.service.ISysMenuService;
import com.liangjian11.ums.dao.foo.SysMenuMapper;
import com.liangjian11.ums.model.SysMenu;
import com.liangjian11.ums.model.Account;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Objects;

@Service
@Transactional(transactionManager = "fooManager")
public class SysMenuServiceImpl extends ServiceImpl<SysMenuMapper, SysMenu> implements ISysMenuService {

    @Override
    @Transactional(readOnly = true)
    public List<SysMenu> getResourcesByUserAndAppKey(Account currentAccount, String applicationKey) {

        List<SysMenu> SysMenuList = null;

        if (Objects.nonNull(currentAccount) && Objects.nonNull(currentAccount.getId()) && Objects.nonNull(applicationKey)) {
            SysMenuList = this.baseMapper.getResourcesByUserAndAppKey(currentAccount.getId(), applicationKey);
        }

        return SysMenuList;

    }

    @Override
    public List<SysMenu> getResourcesByAppKey(String applicationKey) {

        List<SysMenu> SysMenuList = null;

        if (StringUtils.isNotBlank(applicationKey)) {
            SysMenuList = this.baseMapper.getResourcesByAppKey(applicationKey);
        }

        return SysMenuList;
    }

}
