package com.liangjian11.ums.service.impl;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.liangjian11.ums.dao.foo.UserRoleMapper;
import com.liangjian11.ums.model.UserRole;
import com.liangjian11.ums.service.IUserRoleService;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.liangjian11.ums.web.result.ResultInfo;
import com.liangjian11.ums.web.result.ResultUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(transactionManager = "fooManager")
public class UserRoleServiceImpl extends ServiceImpl<UserRoleMapper, UserRole> implements IUserRoleService {

    @Autowired
    private UserRoleMapper userRoleMapper;

    @Override
    @Transactional( propagation = Propagation.REQUIRED,rollbackFor = RuntimeException.class)
    public ResultInfo insertBatchUserRoles(List<UserRole> userRoleList) {
        userRoleMapper.delete(new EntityWrapper<UserRole>().eq("cast(AccountId as varchar(36))",userRoleList.get(0).getAccountId()));
        for (UserRole userRole : userRoleList) {
            userRoleMapper.insert(userRole);
        }
        return ResultUtil.createSuccess(200,"批量更改用户角色成功");
    }
}
