package com.liangjian11.ums.service.impl.organization;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.liangjian11.ums.dao.foo.organization.OrgdocMapper;
import com.liangjian11.ums.dao.foo.organization.OrgdocResourceMapper;
import com.liangjian11.ums.model.organization.OrgdocResource;
import com.liangjian11.ums.service.organization.OrgdocResourceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * (Orgdoc)表服务实现类
 *
 * @author hsw
 * @since 2020-04-14 14:12:53
 */
@Service("orgdocResourceService")
public class OrgdocResourceServiceImpl extends ServiceImpl<OrgdocResourceMapper, OrgdocResource> implements OrgdocResourceService {

    @Autowired
    private OrgdocResourceMapper orgdocResourceMapper;

    @Autowired
    private OrgdocMapper orgdocMapper;

    @Override
    public List<OrgdocResource> selectByOrgId(Integer orgId) {
        return orgdocResourceMapper.selectList(new EntityWrapper().eq("OrgId",orgId));
    }

    @Override
    public void deleteBatch(List<OrgdocResource> orgdocResource) {
        orgdocResource.forEach(o -> {
            orgdocResourceMapper.delete(new EntityWrapper<OrgdocResource>().eq("OrgId",o.getOrgId())
                    .and().eq("ResourceId",o.getResourceId()));
        });
        Integer counts = orgdocResourceMapper.selectCount(new EntityWrapper<OrgdocResource>().eq("OrgId", orgdocResource.get(0).getOrgId()));

        orgdocMapper.updateAuthnum(orgdocResource.get(0).getOrgId(), counts);
    }

    @Override
    public void addBatch(List<OrgdocResource> orgdocResource) {
        orgdocResource.forEach(o -> {
            orgdocResourceMapper.insert(o);
        });

        Integer counts = orgdocResourceMapper.selectCount(new EntityWrapper<OrgdocResource>().eq("OrgId", orgdocResource.get(0).getOrgId()));

        orgdocMapper.updateAuthnum(orgdocResource.get(0).getOrgId(), counts);

    }


}