package com.liangjian11.ums.service.impl.organization;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.liangjian11.ums.dao.foo.organization.ResourceTypeMapper;
import com.liangjian11.ums.model.common.FilterRule;
import com.liangjian11.ums.model.common.Option;
import com.liangjian11.ums.model.common.PageExt;
import com.liangjian11.ums.model.organization.Orgdoc;
import com.liangjian11.ums.model.organization.ResourceType;
import com.liangjian11.ums.service.organization.ResourceTypeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * 接口类型表(ResourceType)表服务实现类
 *
 * @author hsw
 * @since 2020-04-14 14:12:53
 */
@Service("resourceTypeService")
public class ResourceTypeServiceImpl extends ServiceImpl<ResourceTypeMapper, ResourceType> implements ResourceTypeService {
    
    @Autowired
    private ResourceTypeMapper resourceTypeDao;


    @Override
    public List<ResourceType> selectAll() {
        return resourceTypeDao.selectAll();
    }

    @Override
    public List<Option> selectAllAsJson() {
        List<ResourceType> resourceTypes = resourceTypeDao.selectAll();
        List<Option> objects = new ArrayList<>();
        resourceTypes.forEach(resourceType -> {
            objects.add(new Option(resourceType.getName(),resourceType.getId().toString(), false));
        });
        return objects;
    }

    @Override
    public Page selectResourceTypePage(PageExt<ResourceType> page) {
        List<FilterRule> filters = page.getFilters();
        StringBuilder pageSql = new StringBuilder(" where 1 = 1 ");
        filters.forEach(filter -> {
            if(!"".equals(filter.getField()) && !"".equals(filter.getValue())) pageSql.append(filter.toSql());
        });
        int count =  resourceTypeDao.selectResourceTypeCount(new String(pageSql));

        pageSql.append(" order by id asc offset ")
                .append((page.gePageIndex()-1)*page.getSize())
                .append(" rows fetch next ").append(page.getSize()).append(" rows only ");

        List<Orgdoc> orgdocList = resourceTypeDao.selectResourceTypePage(new String(pageSql));
        page.setRecords(orgdocList);
        page.setTotal(count);
        return page;
    }
}