package com.liangjian11.ums.utils;

import com.fasterxml.jackson.annotation.JsonIgnore;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.ArrayList;
import java.util.List;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class TreeNode {
    @JsonIgnore
    @ApiModelProperty("父节点ID")
    private Integer parentId;
    @JsonIgnore
    @ApiModelProperty("节点ID")
    private Integer id;
    @ApiModelProperty("节点值")
    private String key;
    @ApiModelProperty("节点值2")
    private String title;
    @ApiModelProperty("子节点集合")
    private List<TreeNode> children;

    public static List<TreeNode> RecursiveAddress(List<TreeNode> treeNodes){
        List<TreeNode> trees = new ArrayList<TreeNode>();
        for (TreeNode treeNode : treeNodes) {
            if ("".equals(treeNode.getParentId()) || null==treeNode.getParentId() || treeNode.getParentId()==0) {
                trees.add(findChildren(treeNode,treeNodes));
            }
        }
        return trees;
    }

    /**
     * 递归查找地址子节点
     * @param treeNodes
     * @return
     */
    public static TreeNode findChildren(TreeNode treeNode,List<TreeNode> treeNodes) {
        for (TreeNode it : treeNodes) {
            if(treeNode.getId().equals(it.getParentId())) {
                if (treeNode.getChildren() == null) {
                    treeNode.setChildren(new ArrayList<TreeNode>());
                }
                treeNode.getChildren().add(findChildren(it,treeNodes));
            }
        }
        return treeNode;
    }


}
