package com.liangjian11.ums.web.result;

import com.baomidou.mybatisplus.plugins.Page;
import com.liangjian11.ums.model.common.PageExt;
import lombok.AllArgsConstructor;

/**
 * 系统提示信息封装类
 */
@AllArgsConstructor
public class ResultInfo {

    public static final int TYPE_RESULT_FAIL = 0;//失败
    public static final int TYPE_RESULT_SUCCESS = 1;//成功
    public static final int TYPE_RESULT_WARN = 2;//警告
    public static final int TYPE_RESULT_INFO = 3;//提示信息


    /**
     * 消息提示类型
     */
    private int success;


    /**
     * 提示代码
     */
    private int messageCode;


    /**
     * 提示信息
     */
    private String message;

    /**
     * 结果
     */
    private Object result;

    private Object items;

    private int totalCount;

    public ResultInfo() {
    }

    public ResultInfo(int type, int messageCode, String message, Object result) {
        this.success = type;
        this.messageCode = messageCode;
        this.message = message;
        this.result = result;

        if (result instanceof PageExt) {
            items = ((Page)result).getRecords();
            ((Page)this.result).setRecords(null);
            totalCount = ((Page)result).getTotal();
        }
    }

    public ResultInfo(int type, int messageCode, String message) {
        this.success = type;
        this.messageCode = messageCode;
        this.message = message;
    }

    public int getSuccess() {
        return success;
    }

    public void setSuccess(int type) {
        this.success = type;
    }

    public int getMessageCode() {
        return messageCode;
    }

    public void setMessageCode(int messageCode) {
        this.messageCode = messageCode;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public Object getResult() {
        return result;
    }

    public void setResult(Object result) {
        this.result = result;
    }

    public Object getItems() {
        return items;
    }

    public void setItems(Object items) {
        this.items = items;
    }

    public int getTotalCount() {
        return totalCount;
    }

    public void setTotalCount(int totalCount) {
        this.totalCount = totalCount;
    }
}