package com.liangjian11.ums.web.shiro;

import java.util.UUID;

import com.liangjian11.ums.utils.JWTUtil;
import org.apache.oltu.oauth2.as.issuer.ValueGenerator;
import org.apache.oltu.oauth2.common.exception.OAuthSystemException;

public class JWTGenerator implements ValueGenerator {
    private String params = null;
    public JWTGenerator() {
    }
    public JWTGenerator(String param) {
        this.params = param;
    }

    public String generateValue() throws OAuthSystemException {
        return this.generateValue((params!=null)?params:UUID.randomUUID().toString());
    }

    public String generateValue(String params) throws OAuthSystemException {
        String[] paramarr = params.split("_");
        if(paramarr.length < 4 ){
            throw new OAuthSystemException("prameter : 4 strings concat with _ between");
        }
        String username = paramarr[0];
        String password = paramarr[1];
        String applicationKey = paramarr[2];
        long activeTime = Long.valueOf(paramarr[3]);
        String token = null;
        try {
            token = JWTUtil.sign(username, password, applicationKey, activeTime);
        } catch (Exception var4) {
            throw new OAuthSystemException("OAuth Token cannot be generated.", var4);
        }
        return token;
    }
}
