package com.liangjian11.ums.web.shiro;

import com.liangjian11.ums.utils.JWTUtil;
import org.apache.oltu.oauth2.as.issuer.ValueGenerator;
import org.apache.oltu.oauth2.common.exception.OAuthSystemException;

import java.util.UUID;

public class JWTPassGenerator implements ValueGenerator {
    private String params = null;
    public JWTPassGenerator() {
    }

    public JWTPassGenerator(String param) {
        this.params = param;
    }

    public String generateValue() throws OAuthSystemException {
        return this.generateValue((params!=null)?params:UUID.randomUUID().toString());
    }

    public String generateValue(String params) throws OAuthSystemException {
        String[] paramarr = params.split("_");
        if(paramarr.length < 8 ){
            throw new OAuthSystemException("prameter : 9 strings concat with _ between");
        }
        String username = paramarr[0];
        String password = paramarr[1];
        String applicationKey = paramarr[2];
        String roleKey = paramarr[3];
        String deptCode = paramarr[4];
        String orgKey = paramarr[5];
        String extra = paramarr[6];
        long activeTime = Long.valueOf(paramarr[7]);

        String grantType = paramarr[8];
        String token = null;
        try {
            token = JWTUtil.sign(username, password, applicationKey,roleKey,deptCode,orgKey,extra,
                    activeTime,grantType);
        } catch (Exception var4) {
            throw new OAuthSystemException("OAuth Token cannot be generated.", var4);
        }
        return token;
    }
}
