package com.liangjian11.ums.web.shiro;

import com.auth0.jwt.interfaces.RSAKeyProvider;
import com.liangjian11.ums.utils.CreateSecrteKey;
import com.liangjian11.ums.utils.JWTUtil;
import org.apache.oltu.oauth2.as.issuer.ValueGenerator;
import org.apache.oltu.oauth2.common.exception.OAuthSystemException;

import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.util.UUID;

public class JWTRSA256Generator implements ValueGenerator {
    private String params = null;
    public JWTRSA256Generator() {
    }
    public JWTRSA256Generator(String param) {
        this.params = param;
    }

    public String generateValue() throws OAuthSystemException {
        return this.generateValue((params!=null)?params:UUID.randomUUID().toString());
    }

    public String generateValue(String params) throws OAuthSystemException {
        String[] paramarr = params.split("_");
        if(paramarr.length < 5 ){
            throw new OAuthSystemException("prameter : 5 strings concat with _ between");
        }
        String username = paramarr[0];
        String password = paramarr[1];

        String[] keys = password.split("-");
        if(keys.length < 2 ){
            throw new OAuthSystemException("prameter 2 : 2 strings concat with - between");
        }
        String passworPub = keys[0];
        String passworPriv = keys[1];

        String applicationKey = paramarr[2];
        long activeTime = Long.valueOf(paramarr[3]);

        String grantType = paramarr[4];

        RSAKeyProvider keyProvider = new RSAKeyProvider(){
            public RSAPublicKey getPublicKeyById(String var1){
                try {
                    return (RSAPublicKey)CreateSecrteKey.getPublicKey(passworPub);
                } catch (Exception e) {
                    e.printStackTrace();
                }
                return null;
            }

            public RSAPrivateKey getPrivateKey(){
                try {
                    return (RSAPrivateKey) CreateSecrteKey.getPrivateKey(passworPriv);
                } catch (Exception e) {
                    e.printStackTrace();
                }
                return null;
            }

            public String getPrivateKeyId(){
                return "";
            }
        };

        String token = null;
        try {
            token = JWTUtil.sign(username, keyProvider, applicationKey, activeTime,"RSA256",grantType);
        } catch (Exception var4) {
            throw new OAuthSystemException("OAuth Token cannot be generated.", var4);
        }
        return token;
    }
}
